# 32/64bit spec-file
#
# PCLinuxOS Copyright by Bill Reynolds ( Texstar )
#

%define libname %mklibname %name %major
%define develname %mklibname %name -d
%define staticname %mklibname %name -s -d
%define major	53

%define prefix /usr

%define libname %mklibname %name %major
%define develname %mklibname %name -d
%define staticname %mklibname %name -s -d

%define avfmajor 53
%define avflibname %mklibname avformats-extra %avfmajor
%define postprocmajor 52
%define postproclibname %mklibname postproc-extra %postprocmajor

%define avumajor 51
%define avulibname %mklibname avutil-extra %avumajor
%define swsmajor 2
%define swslibname %mklibname swscaler-extra %swsmajor

%define filtermajor 2
%define filterlibname %mklibname avfilter-extra %filtermajor

%define avresamplemajor 0
%define swresamplemajor 2

%define build_swscaler 2
%define build_x264 0
 

Name:           libav
Version:        0.8.5
Release:        %mkrel 2
Summary:        library to record, convert and stream audio/video
Summary(de):	Bibliothek zum aufnehmen, konverten und streamen von Audio/Video
Group:          System/Libraries
Url:            http://libav.org
Source:         libav-%{version}.tar.xz
License:        GPL-2.0+
BuildRequires:  texlive
BuildRequires:	SDL-devel
BuildRequires:	libtheora-devel
BuildRequires:	libvorbis-devel
BuildRequires:	libjack-devel
BuildRequires:	libdc1394-devel
BuildRequires:	libschroedinger-devel
BuildRequires:	libvpx-devel
BuildRequires:	jpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	bzip2-devel
BuildRequires:	vdpau-devel
BuildRequires:	libva-devel
BuildRequires:	yasm
BuildRequires:	yasm-devel
BuildRequires: 	libfaad2-devel
BuildRequires:	texi2html
%if %build_x264
BuildRequires: x264-devel
%endif
BuildRequires: 	liblame-devel
BuildRequires: 	%{_lib}opencore-amrnb-devel
BuildRequires: 	%{_lib}opencore-amrwb-devel
BuildRequires: 	libfaac-devel librtmp-devel %{_lib}xvid4-devel
Requires:	%libname = %version-%release
Provides:	avconv >= %version
Provides:	avprobe >= %version
Provides:	avplay >= %version
Provides:	avserver >= %version 
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Libav is a complete, cross-platform solution to record, convert and stream audio and video.
#german
%description -l de
Libav ist eine Bibliothek zum aufnehmen, konverten und streamen von Audio/Video Dateien.


%files
%defattr(-,root,root)
%doc INSTALL README COPYING.* CREDITS LICENSE Changelog doc/*.txt doc/*.conf doc/APIchanges
%dir %{_datadir}/avconv
%{_bindir}/avconv
%{_bindir}/avprobe
%{_bindir}/avplay
%{_bindir}/avserver
%exclude %{_bindir}/ffmpeg
%{_datadir}/avconv/libvpx-1080p.avpreset
%{_datadir}/avconv/libvpx-1080p50_60.avpreset
%{_datadir}/avconv/libvpx-360p.avpreset
%{_datadir}/avconv/libvpx-720p.avpreset
%{_datadir}/avconv/libvpx-720p50_60.avpreset
%{_datadir}/avconv/libx264-baseline.avpreset
%{_datadir}/avconv/libx264-fast.avpreset
%{_datadir}/avconv/libx264-fast_firstpass.avpreset
%{_datadir}/avconv/libx264-faster.avpreset
%{_datadir}/avconv/libx264-faster_firstpass.avpreset
%{_datadir}/avconv/libx264-ipod320.avpreset
%{_datadir}/avconv/libx264-ipod640.avpreset
%{_datadir}/avconv/libx264-lossless_fast.avpreset
%{_datadir}/avconv/libx264-lossless_max.avpreset
%{_datadir}/avconv/libx264-lossless_medium.avpreset
%{_datadir}/avconv/libx264-lossless_slow.avpreset
%{_datadir}/avconv/libx264-lossless_slower.avpreset
%{_datadir}/avconv/libx264-lossless_ultrafast.avpreset
%{_datadir}/avconv/libx264-main.avpreset
%{_datadir}/avconv/libx264-medium.avpreset
%{_datadir}/avconv/libx264-medium_firstpass.avpreset
%{_datadir}/avconv/libx264-placebo.avpreset
%{_datadir}/avconv/libx264-placebo_firstpass.avpreset
%{_datadir}/avconv/libx264-slow.avpreset
%{_datadir}/avconv/libx264-slow_firstpass.avpreset
%{_datadir}/avconv/libx264-slower.avpreset
%{_datadir}/avconv/libx264-slower_firstpass.avpreset
%{_datadir}/avconv/libx264-superfast.avpreset
%{_datadir}/avconv/libx264-superfast_firstpass.avpreset
%{_datadir}/avconv/libx264-ultrafast.avpreset
%{_datadir}/avconv/libx264-ultrafast_firstpass.avpreset
%{_datadir}/avconv/libx264-veryfast.avpreset
%{_datadir}/avconv/libx264-veryfast_firstpass.avpreset
%{_datadir}/avconv/libx264-veryslow.avpreset
%{_datadir}/avconv/libx264-veryslow_firstpass.avpreset
%{_mandir}/man1/avconv.1*
%{_mandir}/man1/avplay.1*
%{_mandir}/man1/avprobe.1*
%{_mandir}/man1/avserver.1*
%exclude %{_mandir}/man1/ffmpeg.1*


#------------------ library -------------------------------

%package -n %{libname}
Group:          System/Libraries
Summary:        Shared library part of libav
Summary(de):	Gemeinsam genutzte Bibliothek Teil von libav
Provides:       liblibav = %{version}-%{release}
Conflicts:	%mklibname ffmpeg 51

%description -n %{libname}
Libav is a complete, cross-platform solution to record, convert and stream audio and video.
#german
%description -n %{libname} -l de
Libav ist eine Bibliothek zum aufnehmen, konverten und streamen von Audio/Video Dateien.

%post -n %{libname}
/sbin/ldconfig


%postun -n %{libname}
/sbin/ldconfig

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/libavcodec.so.%{major}*



#----------------- post lib --------------------------------------

%package -n %{postproclibname}
Group:          System/Libraries
Summary:        Shared library part of libav
Summary(de):	Gemeinsam genutzte Bibliothek Teil von libav
Conflicts:	libpostproc%{postprocmajor} >= 1.0.1

%description -n %{postproclibname}
Libav is a complete, cross-platform solution to record, convert and stream audio and video.
#german
%description -n %{postproclibname} -l de
Libav ist eine Bibliothek zum aufnehmen, konverten und streamen von Audio/Video Dateien.

%files -n %postproclibname
%defattr(-,root,root)
%{_libdir}/libpostproc.so.%{postprocmajor}*


#------------------- avflib ----------------------------------

%package -n %{avflibname}
Group:          System/Libraries
Summary:        Shared library part of libav
Summary(de):	Gemeinsam genutzte Bibliothek Teil von libav

%description -n %{avflibname}
Libav is a complete, cross-platform solution to record, convert and stream audio and video.
#german
%description -n %{avflibname} -l de
Libav ist eine Bibliothek zum aufnehmen, konverten und streamen von Audio/Video Dateien.
%post -n %{avflibname}
/sbin/ldconfig


%postun -n %{avflibname}
/sbin/ldconfig

%files -n %{avflibname}
%defattr(-,root,root)
%{_libdir}/libavformat.so.%{avfmajor}*
%{_libdir}/libavdevice.so.%{avfmajor}*
#%{_libdir}/libavresample.so.%{avresamplemajor}*


#--------------- avulib ----------------------------------------

%package -n %{avulibname}
Group:          System/Libraries
Summary:        Shared library part of libav
Summary(de):	Gemeinsam genutzte Bibliothek Teil von libav
Conflicts:	libavutil%{avumajor} >= 1.0.1

%description -n %{avulibname}
Libav is a complete, cross-platform solution to record, convert and stream audio and video.
%description -n %{avulibname} -l de
Libav ist eine Bibliothek zum aufnehmen, konverten und streamen von Audio/Video Dateien.

%post -n %{avulibname}
/sbin/ldconfig


%postun -n %{avulibname}
/sbin/ldconfig

%files -n %{avulibname}
%defattr(-,root,root)
%{_libdir}/libavutil.so.%{avumajor}*

#-------------------- swslib -----------------------------------

%package -n %{swslibname}
Group:          System/Libraries
Summary:        Shared library part of libav
Summary(de):	Gemeinsam genutzte Bibliothek Teil von libav
Requires:	%{avulibname} = %{version}-%release
Conflicts:	libswscaler%{swsmajor} >= 1.0.1

%description -n %{swslibname}
Libav is a complete, cross-platform solution to record, convert and stream audio and video.
#german
%description -n %{swslibname} -l de
Libav ist eine Bibliothek zum aufnehmen, konverten und streamen von Audio/Video Dateien.

%post -n %{swslibname}
/sbin/ldconfig


%postun -n %{swslibname}
/sbin/ldconfig

%if %build_swscaler
%files -n %{swslibname}
%defattr(-,root,root)
%{_libdir}/libswscale.so.%{swsmajor}*
#%{_libdir}/libswresample.so.%{swresamplemajor}*
%endif

#---------------------- filter lib -------------------------------

%package -n %{filterlibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg
Summary(de):	Gemeinsam genutzte Bibliothek Teil von ffmpeg

%description -n %{filterlibname}
libav is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libav if you want to encode multimedia streams.
#german
%description -n %{filterlibname} -l de
libav ist ein schneller Realtime Audio-/Videokonferenzen Encoder, 
Streaming Server, und ein generische Audio- und Videodatei Konverter. 

Von einer Standard-Video4Linux Video Quelle kann ffmpeg den Datenstrom 
abgreifen und in verschiedene Dateiformate codieren. Sound wird 
komprimiert in MPEG Audio Layer 2 oder mit einen AC3 kompatibel Stream. 

Installieren Sie libav, wenn Sie Multimedia-Datenströme codieren 
möchten.

%post -n %{filterlibname}
/sbin/ldconfig


%postun -n %{filterlibname}
/sbin/ldconfig

%files -n %{filterlibname}
%defattr(-,root,root)
%{_libdir}/libavfilter.so.%{filtermajor}*

#------------------- devel ---------------------------   

%package -n %develname
Summary:        devel-library to record, convert and stream audio/video
Summary(de):	Devel-Bibliothek zum aufnehmen, konverten und streamen von Audio/Video
Group:          Development/Libraries
Requires:       %{_lib}libav%{major} = %{version}-%{release}
Conflicts:	%{_lib}ffmpeg-devel


%description -n %develname
Libav is a complete, cross-platform solution to record, convert and stream audio and video.

Devel package for %name.
#german
%description -n %develname -l de
Devel-Bibliothek zum aufnehmen, konverten und streamen von Audio/Video.

Entwicklerdateien zum erstellen von Anwendungen basierend auf %name.

%files -n %develname
%defattr(-,root,root)
%dir %{_includedir}/libavcodec
%dir %{_includedir}/libavdevice
%dir %{_includedir}/libavfilter
%dir %{_includedir}/libavformat
%dir %{_includedir}/libavutil
%dir %{_includedir}/libswscale
%dir %{_includedir}/libpostproc
%dir %{_libdir}/pkgconfig
%{_includedir}/libavcodec/avcodec.h
%{_includedir}/libavcodec/avfft.h
%{_includedir}/libavcodec/dxva2.h
%{_includedir}/libavcodec/opt.h
%{_includedir}/libavcodec/vaapi.h
%{_includedir}/libavcodec/vda.h
%{_includedir}/libavcodec/vdpau.h
%{_includedir}/libavcodec/version.h
%{_includedir}/libavcodec/xvmc.h
%{_includedir}/libavdevice/avdevice.h
%{_includedir}/libavfilter/avfilter.h
%{_includedir}/libavfilter/avfiltergraph.h
%{_includedir}/libavfilter/buffersrc.h
%{_includedir}/libavfilter/version.h
%{_includedir}/libavfilter/vsrc_buffer.h
%{_includedir}/libavformat/avformat.h
%{_includedir}/libavformat/avio.h
%{_includedir}/libavformat/version.h
%{_includedir}/libavutil/adler32.h
%{_includedir}/libavutil/aes.h
%{_includedir}/libavutil/attributes.h
%{_includedir}/libavutil/audioconvert.h
%{_includedir}/libavutil/avassert.h
%{_includedir}/libavutil/avconfig.h
%{_includedir}/libavutil/avstring.h
%{_includedir}/libavutil/avutil.h
%{_includedir}/libavutil/base64.h
%{_includedir}/libavutil/bswap.h
%{_includedir}/libavutil/common.h
%{_includedir}/libavutil/cpu.h
%{_includedir}/libavutil/crc.h
%{_includedir}/libavutil/dict.h
%{_includedir}/libavutil/error.h
%{_includedir}/libavutil/eval.h
%{_includedir}/libavutil/fifo.h
%{_includedir}/libavutil/file.h
%{_includedir}/libavutil/imgutils.h
%{_includedir}/libavutil/intfloat_readwrite.h
%{_includedir}/libavutil/intreadwrite.h
%{_includedir}/libavutil/lfg.h
%{_includedir}/libavutil/log.h
%{_includedir}/libavutil/lzo.h
%{_includedir}/libavutil/mathematics.h
%{_includedir}/libavutil/md5.h
%{_includedir}/libavutil/mem.h
%{_includedir}/libavutil/opt.h
%{_includedir}/libavutil/parseutils.h
%{_includedir}/libavutil/pixdesc.h
%{_includedir}/libavutil/pixfmt.h
%{_includedir}/libavutil/random_seed.h
%{_includedir}/libavutil/rational.h
%{_includedir}/libavutil/samplefmt.h
%{_includedir}/libavutil/sha.h
%{_includedir}/libavutil/intfloat.h
%{_includedir}/libswscale/swscale.h
%{_includedir}/libpostproc/postprocess.h
%{_libdir}/pkgconfig/libavcodec.pc
%{_libdir}/pkgconfig/libavdevice.pc
%{_libdir}/pkgconfig/libavfilter.pc
%{_libdir}/pkgconfig/libavformat.pc
%{_libdir}/pkgconfig/libavutil.pc
%{_libdir}/pkgconfig/libswscale.pc
%{_libdir}/pkgconfig/libpostproc.pc
%{_libdir}/libswscale.so
%{_libdir}/libavutil.so
%{_libdir}/libavformat.so
%{_libdir}/libavfilter.so
%{_libdir}/libavdevice.so
%{_libdir}/libavcodec.so
%{_libdir}/libpostproc.so

#------------- static files ----------------

%package -n %staticname
Summary:        static-devel-library to record, convert and stream audio/video
Summary(de):	Statische-Devel-Bibliothek zum aufnehmen, konverten und streamen von Audio/Video
Group:          Development/Libraries
Requires:       %{_lib}libav%{major} = %{version}-%{release}
Requires:	%{_lib}libav-devel = %{version}-%{release}


%description -n %staticname
Libav is a complete, cross-platform solution to record, convert and stream audio and video.

Devel package for %name.
#german
%description -n %staticname -l de
Statische-Devel-Bibliothek zum aufnehmen, konverten und streamen von Audio/Video.

Entwicklerdateien zum erstellen von Anwendungen basierend auf %name.

%files -n %staticname
%defattr(-,root,root)
%{_libdir}/libavcodec.a
%{_libdir}/libavdevice.a
%{_libdir}/libavfilter.a
%{_libdir}/libavformat.a
%{_libdir}/libavutil.a
%{_libdir}/libswscale.a
%{_libdir}/libpostproc.a


#------------- build area ------------------

%prep
%setup -q
# Most options are auto-detcetd (CPU optimisations, ...), Only enable shared libraries (and PIC), disable debug symbols and enable use of on-chip SRAM
./configure --prefix=%prefix \
	--libdir=%{_libdir} \
	--shlibdir=%{_libdir} \
	--disable-debug \
	--enable-shared \
	--enable-postproc \
	--enable-pic \
	--enable-sram \
	--enable-gpl \
	--enable-libtheora \
	--enable-libvorbis --disable-encoder=vorbis \
	--enable-libvpx \
	--enable-x11grab \
	--enable-runtime-cpudetect \
	--enable-libdc1394 \
	--enable-libschroedinger \
	--enable-librtmp \
	--enable-libmp3lame \
	--enable-libopencore-amrnb \
	--enable-libopencore-amrwb \
	--enable-version3 \
	%if %build_x264
	--enable-x264 \
	%endif
	--enable-nonfree \
        --enable-libfaac \
	--enable-libxvid \
	--enable-libpulse

%build
%make

%install
%make_install

rm -rf $RPM_BUILD_ROOT/usr/local
%ifarch x86_64
rm -rf $RPM_BUILD_ROOT/usr/lib
%endif


%clean
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%name-%version

%changelog
* Mon Feb 25 2013 pinoc <vogtpet at gmail.com> 0.8.5-2pclos2013
- added {major} in Requires for devel-packages

* Wed Jan 30 2013 daniel <meisssw01 at gmail.com> 0.8.5-1leiche2013
- upstream tarball

* Mon Jan 07 2013 daniel <meisssw01 at gmail.com> 0.8.4-3pclos2013
- rebuild to produce more lib package, without x264 support


* Fri Nov 16 2012 leiche <meisssw01 at gmail.com> 0.8.4-1pclos2012
- latest version of this branch,
  needed by dvdstyler

* Wed Jun 13 2012 leiche <meisssw01 at gmail.com> 0.8.2-3pclos2012
- add devel conflict with ffmpeg-devel

* Sat Jun 09 2012 leiche <meisssw01 at gmail.com> 0.8.2-2pclos2012
- enable postproc

* Sat May 26 2012 leiche <meisssw01 at gmail.com> 0.8.2-1pclos2012
- initial package

